//String that dictates what the Icon will look like eg.  unit__-
var iconParameters = "";
var titleText = "";
var blankImageSrc = 'symbols/blank.png';

var canvas;
var ctx;

var image1 = new Image();
image1.src = blankImageSrc;
var image2 = new Image();
image2.src = blankImageSrc;
var image3 = new Image();
image3.src = blankImageSrc;
var image4 = new Image();
image4.src = blankImageSrc;
var images = [image1, image2, image3, image4];

var topCenterAmplifier = new Image();
topCenterAmplifier.src = blankImageSrc;
var topRightAmplifier = new Image();
topRightAmplifier.src = blankImageSrc;
var bottomCenterAmplifier = new Image();
bottomCenterAmplifier.src = blankImageSrc;

//02_015_005_010

//02_015_005_010_005
var armored = new Image();
armored.src = 'symbols/02_armored.png';
var icons = [backgrounds, mainIcons, modifier_set1_images, modifier_set2_images]
// Image Builder Functions\

var lastPageIndex = 0;
var pageProgression = 0;

function ProgressPage()
{
    pageProgression++;
}

function LogHistory()
{
    lastPageIndex = pageProgression;//document.getElementById("navigationIFrame").contentWindow.history.length;
}
function goBack()
{
    document.getElementById("navigationIFrame").contentWindow.history.go(-1);
    pageProgression -= 2;
}
function JumpBackToLoggedPosition()
{
    var pageChange = lastPageIndex - pageProgression;
    //console.log("pageChange" + pageChange);
    document.getElementById("navigationIFrame").contentWindow.history.go(pageChange);
    undo();
    resetAmplifiers();
    pageProgression = pageProgression - (pageProgression - lastPageIndex);
    
}

function interpretIconString() {

    initialize();
    
    var pieces = iconParameters.split("*");
    for (var i = 0; i < pieces.length; i++) {
        imageURL = findIcon(pieces[i],icons[i]);
        images[i].src = imageURL;
    }
    for (var i = pieces.length; i < images.length; i++) {
        images[i].src = blankImageSrc;
    }

}

function findIcon(imageTag,iconSet)
{
    for (var i = 0; i < iconSet.length; i++) {
		///console.log("icon ID =" + iconSet[i].idLookup);
        if (iconSet[i].idLookup == imageTag)
        {
            return iconSet[i].imgSrc;
        }
    }
    return blankImageSrc;
}
function findIconSrcFromArray(idLookUp, array) {
    for (var i = 0; i < array.length; i++) {
        if (array[i].idLookup == idLookUp)
            return array[i].imgSrc;
    }
    return blankImageSrc;
}
// every page
function initialize() {
    canvas = document.getElementById("canvas_1");
    ctx = canvas.getContext("2d");
}

function clearImage() {
    if(ctx!=null)
        ctx.clearRect(1, 1, 900, 500);
}
function drawImageFromURL(imageURL, image)
{
    image.src = imageURL;
    drawImage(image);
}
function drawImages()
{
    clearImage();
    drawImage1();
    drawImage2();
    drawImage3();
    drawImage4();
    drawTopCenterAmplifier();
    drawBottomCenterAmplifier();
    drawTopRightAmplifier();
}
function drawImage1()
{
    if(ctx!=null)
    ctx.drawImage(image1,285, 85);
}
function drawImage2()
{
    if (ctx != null)
    ctx.drawImage(image2, 285, 85);
}
function drawImage3() {
    if (ctx != null)
    ctx.drawImage(image3, 285, 85);
}
function drawImage4() {
    if (ctx != null)
    ctx.drawImage(image4, 285, 85);
}
function drawTopCenterAmplifier() {
    if (ctx != null)
        ctx.drawImage(topCenterAmplifier, 285, 85);
}
function drawTopRightAmplifier() {
    if (ctx != null)
        ctx.drawImage(topRightAmplifier, 285, 85);
}
function drawBottomCenterAmplifier() {
    if (ctx != null)
        ctx.drawImage(bottomCenterAmplifier, 285, 85);
}
function drawImage(image) {
    ctx.drawImage(image, 285, 85);
}

function changeHeaderTitle(titleText)
{
    document.getElementById("headerTitle").innerHTML = titleText;
}
function changeTitle(symbolName) {
    if(titleText!="")
        titleText+= '/';
    titleText += symbolName;
    document.getElementById("symbolnamediv").innerHTML = titleText;
}
function appendIconParameter(iconText) {
    iconParameters += iconText + "-";
    interpretIconString();
}

function reset() {
    titleText = titleText.split("/")[0]
	//titleText="";
	resetIcon();
	resetAmplifiers();
	document.getElementById("symbolnamediv").innerHTML = titleText;	
}
function resetIcon()
{
    iconParameters = "";
    interpretIconString();
}
function resetAmplifiers()
{
    topCenterAmplifier.src = blankImageSrc;
    topRightAmplifier.src = blankImageSrc;
    bottomCenterAmplifier.src = blankImageSrc;
}

function undo()
{
    undoTitle();
    undoIconParameter();
}
function undoTitle() {
    var pieces = titleText.split('/');
    titleText = "";
    if (pieces.length > 1) {

        titleText = pieces[0];
        for (var i = 1; i < pieces.length - 1; i++) {
            titleText += '/' + pieces[i];
        }
    }
    document.getElementById("symbolnamediv").innerHTML = titleText;
}
function undoTitleSections(sections) {
    var pieces = titleText.split('/');
    titleText = "";
    if (pieces.length > sections) {

        titleText = pieces[0];
        for (var i = 1; i < pieces.length - sections; i++) {
            titleText += '/' + pieces[i];
        }
    }
    document.getElementById("symbolnamediv").innerHTML = titleText;
}
function undoIconParameter() {
    var pieces = iconParameters.split("-");
    iconParameters = "";
    for (var i = 0; i < pieces.length - 2; i++) {
        appendIconParameter(pieces[i]);
    }
    if(iconParameters.length ==2)
        iconParameters = "";
}

function ChangeTopCenterAmplifier(amplifierID)
{
    if (amplifiers != null)
        topCenterAmplifier.src = findIconSrcFromArray(amplifierID, amplifiers);
    else
        topCenterAmplifier.src = blankImageSrc;
}
function ChangeTopRightAmplifier(amplifierID) 
{
    if (amplifiers != null)
        topRightAmplifier.src = findIconSrcFromArray(amplifierID, amplifiers);
    else
        topRightAmplifier.src = blankImageSrc;
}
function ChangeBottomCenterAmplifier(amplifierID)
{
    if (amplifiers != null)
        bottomCenterAmplifier.src = findIconSrcFromArray(amplifierID, amplifiers);
    else
        bottomCenterAmplifier.src = blankImageSrc;
}
