//ADD BUTTON FUNCTIONS

//add a textarea with the Add Action button and Add Belief button
$(document).on('pageinit', function () {
	$(".worksheet").on("click", ".add_a,.add_b", function () {
		if ( $(this).hasClass('add_b') ) {
			var $beliefDiv  = $(this).parents('.goal_section').children('.goal_beliefs');
			$beliefDiv.append('<textarea name="textarea" style="height: 52px;" placeholder="Enter an affirmation"></textarea>').enhanceWithin();
		} else {
			var $actionDiv  = $(this).parents('.goal_section').children('.goal_actions');
			$actionDiv.append('<textarea name="textarea" style="height: 52px;" placeholder="Enter an action"></textarea>').enhanceWithin();
		}
	});
	
	newSection();
});
//add a Section with the Add Priority button
function newSection() {
	$(".section.group").on("click", ".add_p", function () {
		//add section name
		var count = $('.goal_section').length + 1;		
		
		//add section
		var $sectionDiv  = $(this).parents('.section.group').children('.worksheet');
		$sectionDiv.append('\
		<div class="goal_section">\
	                <p class="subhead">Priority Area ' + count + '</p>\
	                <p>Priority</p>\
	                <textarea class="goal_priority" name="textarea" style="height: 52px;" placeholder="Enter your priority"></textarea>\
	                <p>Action Statements</p>\
	                <div class="goal_actions">\
	                	<textarea name="textarea" style="height: 52px;" placeholder="Enter an action"></textarea>\
		                <textarea name="textarea" style="height: 52px;" placeholder="Enter an action"></textarea>\
		                <textarea name="textarea" style="height: 52px;" placeholder="Enter an action"></textarea>\
	                </div>\
	                <form><div data-role="navbar" data-iconpos="right" class="add_action">\
	                      <ul><li><a class="add_a" value="Add Statement">Add Action</a></li><li><p>&nbsp;</p></li><li><p>&nbsp;</p></li>\
	                 	  </ul></div>\
	                </form>\
	                <p>Belief Statements</p>\
	                <div class="goal_beliefs">\
	                	<textarea name="textarea" style="height: 52px;" placeholder="Enter affirmation"></textarea>\
	                	<textarea name="textarea" style="height: 52px;" placeholder="Enter affirmation"></textarea>\
	                	<textarea name="textarea" style="height: 52px;" placeholder="Enter affirmation"></textarea>\
	                </div>\
	                <form><div data-role="navbar" data-iconpos="right" class="add_action">\
	                      <ul><li><a class="add_b" value="Add Statement">Add Statement</a></li><li><p>&nbsp;</p></li><li><p>&nbsp;</p></li>\
	                      </ul></div>\
	                </form>\
                </div>').enhanceWithin();
	});	
}

//SAVE BUTTON FUNCTIONS
                       
function getSavedGoals() {
    //return ("goals" in window.localStorage) ?
	//	(JSON.parse(window.localStorage["goals"])) :
    //	[];
    return (window.external.ContainsKey("goals")) ? (JSON.parse(window.external.GetItem("goals"))) : [];
}
//Save dialog box (pop-up)



function saveGoal() {
	var goals = getSavedGoals();
	var goalTitle = $('.goal_title').val();
	var goalOutcome = $(".goal_outcome").val();
	
	//doesn't work	
	if (goalTitle === "" || goalOutcome === "") {
		if (goalTitle === "") {
			alert('no title');
			$('textarea[id=goal_title]').val('Enter a goal title to save your worksheet');
			//$('textarea[id=goal_title]').selectmenu('refresh', true);
		} 
		if (goalOutcome === "") {
			alert('no outcome');
			$('textarea[id=goal_outcome]').val('A worksheet requires an outcome');
			//$('textarea[id=goal_outcome]').selectmenu('refresh', true);
		}
		return;
	}

	//TO DO:check if goal is being edited or new: employ the initial a dialog box

	//TO DO: get rest of values from page here
	
	// holds all sections for this worksheet
	var allSections = [];
	// loop through each .goal_section in this worksheet
	$(".goal_section").each(function () {
		//this means whatever I'm eaching
		var goalPriority = $(this).find(".goal_priority").val();
		
		var allActions = [];
		//this is a jQuery variable so jQuery functions can be called on this variable
		var $goalActions = $(this).find(".goal_actions");
		$goalActions.children('textarea').each(function () {
			//"this" means whatever I'm eaching
			allActions.push($(this).val());
		});
		var allBeliefs = [];
		//this is a jQuery variable so jQuery functions can be called on this variable
		var $goalBeliefs = $(this).find(".goal_beliefs");
		$goalBeliefs.children('textarea').each(function () {
			//"this" means whatever I'm eaching
			allBeliefs.push($(this).val());
		});
		
		// create an object for the current section
		var currentSection = {
			"priority": goalPriority,
			"actions" : allActions,
			"beliefs" : allBeliefs
			//add things here

		};
		// add the current section to the allSections array
		allSections.push(currentSection);
	});
	
	// create the goal
	var goal = {
		"title" : goalTitle,
		"outcome" : goalOutcome,
		"sections": allSections
	};
	// add the goal to goals
	goals.push(goal);
	// save goals back to localStorage
    //window.localStorage["goals"] = JSON.stringify(goals);
	window.external.SetItem("goals", JSON.stringify(goals));
}

function loadGoal(index) {
	// get the worksheet contents
	var goals = getSavedGoals();
	
	// ensure requested worksheet exists
	if (goals.length >= index) {
		window.console.log("loading goal")
		var goal = goals[index];
		//grab.html
		$(".title").html(goal.title);
		$("#goal").html(goal.outcome);
		//loop through sections and add content
			
		var s = 0;
		for (s = 0; s < goal.sections.length; s++) {
			//for each entry in local storage for actions
			var actions = "";
			for (var a = 0; a < goal.sections[s].actions.length; a++) {
				actions += '<li class="entry">' + goal.sections[s].actions[a] + '</li>';
			}
			//for each entry in local storage for beliefs
			var beliefs = "";
			for (var b = 0; b < goal.sections[s].beliefs.length; b++) {
				beliefs += '<li class="entry">' + goal.sections[s].beliefs[b] + '</li>';
			}
			var $rawhtml = $('<div>\
	                <p class="subhead">Priority Area ' + (s + 1) + '</p>\
	                <p><b class="hilite">Priority Area</b>&nbsp;<span>' + goal.sections[s].priority + '</span></p>\
	                <p><b class="hilite">Action Statements</b></p>\
	                <div><ul data-role="listview">' + actions + '</ul></div>\
	                <p><b class="hilite">Belief Statements</b></p>\
	                <div><ul data-role="listview">' + beliefs + '</ul></div>\
                </div>');
			$('.worksheet').append($rawhtml).enhanceWithin();
		}	
	//worksheet does not exist
	} else {
	//TODO: tell user doesn't exist, or something
	}
}

function loadSavedGoals() {
	// get the goals
	var goals = getSavedGoals();
	
	// ensure there are goals to display
	if (goals.length == 0) {
		// tell the user none exist
		$("#savedGoalsMessage").html("There are no saved worksheets");
		
		// exit early, nothing to do here.
		return;
	}
	
	// loop through each goal, printing a link
	var linkID = '';
	for (var i = 0; i < goals.length; i++) {
		$("#savedGoals").append('<li><a href="#" id="linkID_' + i + '" class="goal_link ui-btn ui-icon-right ui-btn-icon-right ui-nodisc-icon">&nbsp;' + goals[i].title + '&nbsp;</a></li>').enhanceWithin();
	}
	// make it pretty
	$("#savedGoals").enhanceWithin();
	
	// let the user know the goals are loaded
	$("#savedGoalsMessage").html("Select a Goal to view:");
}

//HELPER FUNCTIONS
function checkStorage() {
    window.console.log(window.external.GetItem("title"));//localStorage.getItem('title'));
}

// to run when device is ready
function onDeviceReady() {
	// if we're on the page with #savedGoals
	if ($("#savedGoals").length == 1) {
		// load the saved goals on ready
		loadSavedGoals();
		// attach click handler to #savedGoals
		$("#savedGoals").on("click", "a.goal_link", function (e) {
		    window.console.log("clicked a goal");
		    //window.localStorage["currentGoal"] = 0;
		    window.external.SetItem("currentGoal", 0);
			//grab the jQuery mobile active page and drag the html file into it
			$(':mobile-pagecontainer').pagecontainer("change", "19_030_010_001.html", {
				transition: "none"
			});
			//extract the number from the "linkID_#" 
			var linkIdNum = this.id.substring(7);
			//hack to make the page load the goal
			setTimeout(function() { loadGoal(linkIdNum); }, 1000);
		});
	}
	// if we're loading a specific goal
	if ($("#loaded_goal").length == 1) {
	    // ensure we are loading a goal
	    //if ("currentGoal" in window.localStorage) {
	    if (window.external.ContainsKey("currentGoal")) {
			// get the index of the goal       
		    //var index = parseInt(window.localStorage["currentGoal"]);
		    var index = parseInt(window.external.GetItem("currentGoal"));
			// remove the special loaded goal
			//window.localStorage.removeItem("currentGoal");
			// load the goal
			loadGoal(index);
		}
		// we are not loading a goal
		else {
			// tell user no goal was selected
			$("#loaded_goal").html("No goal was selected.");		
			//TO DO: style the above
		}
	}
}

// setup pageinit to wait for device if needed
$(document).on('pageinit', function() {
	// if mobile
	if (navigator.userAgent.match(/(iPhone|iPod|iPad|Android|BlackBerry)/)) {
		// add event listener for cordova deviceready
        document.addEventListener("deviceready", onDeviceReady, false);
    } else {
    	// not on mobile, run deviceready handler immediately
        onDeviceReady();
    }
});

/*
 * localStorage
 * 
 * [GET] two ways to access the value for the key "title":
 *   var tmp = window.localStorage["title"]
 *   var tmp = window.localStorage.getItem("title")
 * 
 * [SET] two ways to set the value for the key "title":
 *   window.localStorage["title"] = "blah";
 *   window.localStorage.setItem("title", "blah");
 * 
 *  var blah = $('.goal_title').val();
 *  window.localStorage["title"] = blah;
 * 
 *  $('.titleArea').html(blah);
 * 
 * 
 */